<?php
// Your IPinfo API token
$ipinfoToken = '4522ea60c7689f';

// Function to get IP address of the user
function getUserIP() {
    if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
        $ip = $_SERVER['HTTP_CLIENT_IP'];
    } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
        $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
    } else {
        $ip = $_SERVER['REMOTE_ADDR'];
    }
    return $ip;
}

// Function to check if IP is residential
function isResidentialIP($ip, $token) {
    $url = "https://ipinfo.io/$ip?token=$token";

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    $result = curl_exec($ch);
    curl_close($ch);

    $data = json_decode($result, true);

    if (isset($data['privacy']) && isset($data['privacy']['vpn'])) {
        // Check if the IP is not from a VPN or datacenter
        return !$data['privacy']['vpn'] && !$data['privacy']['proxy'] && !$data['privacy']['hosting'];
    }

    return false;
}

// Get user's IP
$userIP = getUserIP();

// Check if the IP is residential
if (!isResidentialIP($userIP, $ipinfoToken)) {
    // Deny access if IP is not residential
    die("Access denied.");
}

// If residential, continue with the rest of the website logic
// (Do not output any message here, just proceed)
?>
